#!/usr/bin/perl


#
# This CGI script is run each time an ad banner
# is clicked on, which isn't very often.
#
# Notes:
#	- inputs are read in a comma-delimited $ENV{'QUERY_STRING'} 
#	- 'url' CGI input to redirects drop-list style HTML ads
#	- optional third QUERY_STRING field to track clicks on parts of HTML ads
#
#
# Modified:  Kurt Gray -- Fri Aug 27 12:02:26 EDT 1999     Adapted for Freshmeat
#            Kurt Gray -- Wed Nov 22 15:37:12 EST 2000     Moved ad_info.dat to /usr/local/adsystem/dat; Added mod_perl fix 


    my $datfilepath                         = '/usr/local/adsystem/dat';    # Path where ad_info.dat file is 
    my $ad_found                            = 0;
    my ($currentid, $height, $width, $url)  = ();

# Read inputs from QUERY_STRING and/or CGI
    
    my ($tmp_pagename, $tmp_adid, $tmp_url_input) = split(',', $ENV{'QUERY_STRING'});
    my  $pagename                                 = substr($tmp_pagename, 0, 40) if $tmp_pagename;
    my  $adid                                     = $1 if $tmp_adid =~ /(\w{10})/;
    my  $url_input                                = substr($tmp_url_input, 0, 120) if $tmp_url_input;


# Read CGI inputs from ad in case any ads have a droplist from which the user selects a target url

#	use FormParse;
#	$form = new FormParse;
#	$form->Parse;


# Determine add ad target depending on input

    if ( $url_input ) {
	
	$url = $url_input;

#    } elsif ($form->{'in'}->{'url'}) {
#	$url = $form->{'in'}->{'url'};

    } else {

	if ( $adid ) {
	    if ( open ADINFO, "< $datfilepath/ad_info.dat" ) {
		while (<ADINFO>) {
		    if ($_ =~ /^$adid\s/) {
			$ad_found++;
			($currentid,$height,$width,$url) = split(/\t/,$_);
			last;
		    }
		}
		close ADINFO;
	    } else {
		$errors .= "<BR><B>ERROR: Can not read ad_info.dat table: $!</B><BR>";
	    }
	} else {
	    $errors .= "<BR><B>ERROR: No AdID input was specified.</B><BR>";
	}

	if ( $ad_found < 1 ) {
	    $errors .= "<BR><B>ERROR: AdID $adid was not found in ad_info table.</B><BR>";
	}

    } # if url_input


# Redirect browser to target URL

    if ( $url ) {

	if ( $ENV{'MOD_PERL'} ) {
	    my $CRLF = "\015\012";
	    print "HTTP/1.1 302 Move$CRLF";
	    print "Location: $url$CRLF$CRLF";
	    exit(0);
	} else {
	    print "Location: $url\n\n";
	} 

    } else {

	if ( $ENV{'MOD_PERL'} ) {
	    my $CRLF = "\015\012";
	    print "HTTP/1.1 200 OK$CRLF";
	    print "Content-type: text/html$CRLF$CRLF";
	    exit(0);
	} else {
	    print "Content-type: text/html\n\n";
	}

	print qq|
	    <HTML>
	    <BODY>

	    <H3>Error redirecting to ad target:</H3>

            $ENV{SCRIPT_NAME} can not determine the target URL of the ad you clicked on.
	    <BR>
            $errors
	    <BR>
	    <BR> 
	    Please notify us so we can straighten this out.  Thanks.
	    <BR>
	    <BR>
	    <A HREF="/">Click here</A> to get back to the home page.
	    </BODY>
	    </HTML>
		|;    

    } # if url

__END__
