#!/usr/bin/perl

#
# This is a custom version of adlarge.pl to present
# large ads to those who open an Andover Update HTML 
# e-mail newsletter. This script is both the IMG SRC tag
# and the target url for the large banner in each newsletter.
# 
#
# Modified:   Kurt Gray -- Tue Sep 21 11:23:03 EDT 1999      Hard-coded $adid since too many e-mail clients can't do cookies
#             Colin O'Sullivan --                            Added animfactory newsletter
#             Kurt Gray -- Tue Aug  8 12:10:35 EDT 2000      Added CGI interface for sales people
#             Kurt Gray -- Mon Nov 27 15:29:32 EST 2000      Added baseurl setting; Moved admail_rotate.dat to /usr/local/adsystem/dat/


require '/usr/local/adsystem/dat/ad_mail_alloc.dat';    # Read all current newsletter settings


# Read inputs

   my $newsletter     = $1 if $ENV{QUERY_STRING} =~ /^(\w{3,20}),/;
      $newsletter   ||= 'newsletter';
   my $function       = $1 if $ENV{QUERY_STRING} =~ /,(\w{3,20})/;
      $function     ||= 'rotate';

# Debugging option: read inputs from commandline

   if ( $ARGV[0] =~ /^(\w{3,20}),?(\w{0,20})/ ) {
 	$newsletter = $1;
	$function   = $2;
   }


# Read current settings from ad_mail_alloc.dat

   my $adid         = $adID{         $newsletter };
   my $StartDate    = $Startdate{    $newsletter };
   my $StopDate     = $Stopdate{     $newsletter };
   my $default_adid = $default_adID{ $newsletter };
   my $baseurl      = $baseurl{      $newsletter };


# Check run date for allocated ad -- run default ad if current time is not within run date range

   $cachebuster = time;

   if ( $StartDate > 10 ) {
       if ( $cachebuster < $StartDate ) {
	   $adid = $default_adid;
       }
   }

   if ( $StopDate > 10 ) {
       if ( $cachebuster >= $StopDate ) {
	   $adid = $default_adid;
       }
   }


# If no $adid then choose a default 468x60 banner
 
   # $adid  ||= 'anda0072en';
   $baseurl ||= 'http://' . $ENV{'HTTP_HOST'};


# Display the banner

   if ( $function =~ 'rotate' ) {

       print "Location: $baseurl/banner/$adid.gif\?$cachebuster\n\n";

# Ad was clicked on - Redirect to adlog.pl which then redirects to target url

   } else {

       print "Location: $baseurl/cgi-bin/adlog.pl\?$newsletter,$adid\n\n";

   }


__END__








