#!/usr/bin/perl

#
# This is a CGI interface for browsing, creating, and configuring contact lists
#
# Notes: 
#
#
# Modified:  Kurt Gray -- Mon Jan 15 21:36:01 EST 2001      First rev. hacked out of ad_notes.pl


push @INC, '/usr/local/adsystem/lib/';
require 'ad_config_lib.pl';	        # Site-specific settings for adsystem control scripts
require 'ad_util_lib.pl';	        # Common functions for adsystem scripts

{

# Script settings and base inputs:

    $thisscript           ||= $ENV{'SCRIPT_NAME'};


# Print top of output web page and check user login

    &loginUser( $sales_dept );

    
    $nav_links->{ $sales_dept }->{'Create a Contact List'} = "$ad_contactlists_url?op=edit";

    &getSalesPeople;



# Read form inputs:

    $contactlist_id_in        =  $1 if $form->{'in'}->{'contactlist_id'} =~ /(\d+)/;
    $op                       =  $1 if $form->{'in'}->{'op'} =~ /(\w+)/;
    $op                     ||=  'view' if $contactlist_id_in;
    $function                 =  'save' if $form->{'in'}->{'GoButton'} =~ /Save/;
    $sortby                   =  $1 if $form->{'in'}->{'sortby'} =~ /(\w+)/;


# Save contactlist settings:

    if ( $function eq 'save' ) {

	$contactlist_id         = $contactlist_id_in || time;
	$contactlist_kill       = $form->{'in'}->{ 'contactlist_kill'    };
	$contactlist_owner      = $form->{'in'}->{ 'contactlist_owner'   } || $username;
	$contactlist_partners   = &readCheckboxes( 'contactlist_partners', $numsalespeople );
	$contactlist_subject    = $form->{'in'}->{ 'contactlist_subject' };
	$upload_filename = $1 if $form->{'in'}->{'upfile'}->{'filename'} =~ /([\w\.\-]+)/;

	# $contactlist_private = 'PRIVATE' if $contactlist_type eq 'NOTE'; # Notes are 'NOTE to self' therefore private

	if ( $contactlist_kill eq 'T' ) {
	    $messages .= "NOTICE: Entry removed : $contactlist_id $contactlist_subject <BR>";
	    $ignoring_input++;
	    $op = 'listall';
	    # TODO: Delete message file and attachment file too
	}

	push @replaced_records, $contactlist_id;

	# Save the attached file:

	if ( ! $ignoring_input ) {

	    if ( $upload_filename ) {
		$upload_filepath = "$contactlists_uploadpath/$upload_filename";
		my $upload_filedata = $form->{'in'}->{'upfile'}->{'value'};
		if ( open ( UPFILE, "> $upload_filepath") ) {
		    print UPFILE $upload_filedata;
		    close UPFILE;
		    $messages .= "NOTICE: File attachment saved: $upload_filename <BR>\n";

# TODO: Merge contacts
 
		} else {
		    $error_messages .= "ERROR: Could not store upload file $upload_filename: $! ";
		    $upload_filename = '';
		}
	    } else {

		# Reserve previous file attachment execpt on replies:
		$upload_filename = $1 if $form->{'in'}->{'previous_attachment'} =~ /([\w\.\-]+)/;

	    } # if upload_filename


	    $new_file_data .= join "\t", ( $contactlist_id,
					   $contactlist_owner,
					   $contactlist_partners,
					   $contactlist_subject,
					   $upload_filename,
					   "\n");
	    
	} # if contactlist_kill
	
    } # if Save


# Read all notes data on file, replace overwritten data, append new input data to it, 

    $file_data = $new_file_data;

    if ( open( INFILE, "< $contactlists_idxfile" ) ) { 
	while ( $line = <INFILE>) {
	    next if $line !~ /(\d+)\t/;
	    next if grep /$1/, @replaced_records;
	    $file_data .= $line;
	}
	close INFILE;
    } else {
	$error_messages .= "ERROR: Could not read notes index file $contactlists_idxfile : $! <BR>\n";
    }


# Save new idx file:

    if (( $function eq 'save' ) && ( ! $dontsaveinput )) {

	# TODO: Don't allow users to overwrite each other's notes

	if ( $user_access_level < $sales_dept ) {
	    $error_messages .= "ERROR: Can not save file: User $username does not have write privileges to this interface. <BR>\n"; 
	} else {
	    &BackupAndSaveFile( "$contactlists_idxfile" );
	}

    } # if save changes



# Read all data into a sortable hash:

    foreach $line ( ( split /\n/, $file_data ) ) {
	
	( $tmp_contactlist_id,
	  $tmp_contactlist_owner,
	  $tmp_contactlist_partners,
	  $tmp_contactlist_subject,
	  $tmp_upload_filename ) = split /\t/, $line;

	if ( $sortby eq 'owner' ) {
	    $tmp_key = $tmp_contactlist_owner . "z$tmp_contactlist_id";
	} elsif ( $sortby eq 'name' ) {
	    $tmp_key = $tmp_contactlist_subject . "z$tmp_contactlist_id";
	} elsif ( $sortby eq 'attachment' ) {
	    $tmp_key = $tmp_upload_filename . "z$tmp_contactlist_id";
	} else {
	    $tmp_key = $tmp_contactlist_id;
	} #if sortby

	$sort_list{ $tmp_key } = $line;

    } # foreach data_file line



# Make an HTML edit form for the given note:

    if ( $op eq 'edit' ) {

	&getInfo( $contactlist_id_in );
 
	if ( $contactlist_owner ) {
	    if ( $username ne $contactlist_owner ) {
		print "SORRY: Users are not allowed to reconfigure each others list settings. <BR>";
		exit;
	    }
	} else {
	    $contactlist_owner = $username;
	    $tmp_contactlist_owner = $ad_system_users{ $username }->{'name'};
	}


	$page_contents .= qq|<FORM METHOD=POST ENCTYPE='multipart/form-data' ACTION="$thisscript">
	        <TABLE BGCOLOR=WHITE>
	        <TR BGCOLOR=DDFFCC>   
		<TD ALIGN=RIGHT><B>List Owner: </B></TD><TD> $tmp_contactlist_owner <INPUT TYPE="HIDDEN" VALUE="$contactlist_owner"> </TD>
	         </TR><TR>
                 <TD ALIGN=RIGHT><B>List Name: </B></TD><TD>
		     <INPUT NAME="contactlist_subject" SIZE="40" MAXLENGTH="50" VALUE="$contactlist_subject"></TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD ALIGN=RIGHT><B>Share With: </B></TD><TD> |;

	%drop_list = %ad_sales_people;
	&makeCheckboxes( 'contactlist_partners', $contactlist_partners );

	$page_contents .= qq| </TD>
                 </TR><TR>
                 <TD ALIGN=RIGHT><B>Import ACT Contacts: </B></TD><TD> <INPUT TYPE=FILE NAME="upfile"> </TD>
		</TR><TR BGCOLOR=\#AAAAFF>
		<TD>
		    <INPUT TYPE="HIDDEN" NAME="contactlist_id" VALUE="$contactlist_id">
		    <INPUT TYPE="CHECKBOX" NAME="contactlist_kill" VALUE="T"> Delete this list </TD>
		<TD>
		    <INPUT TYPE="SUBMIT" NAME=GoButton VALUE="Save List Settings"></TD>
		</TR>
		</TABLE>
	    </FORM>
		|;


# View the note:
	
    } elsif ( $op eq 'view' ) {

	&getInfo( $contactlist_id_in );

	$edit_link = qq|<A HREF="$thisscript?op=edit&contactlist_id=$contactlist_id_in">Edit list settings</A>| if $username eq $contactlist_owner;

	$page_contents .= qq|

		<TABLE BGCOLOR=WHITE CELLPADDING=5>
		<TR>
		<TD> </TD>
		<TD ALIGN=MIDDLE BGCOLOR=DDDDDD> $edit_link </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Owner: </B></TD>
		<TD> $tmp_contactlist_owner </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> List Name: </B></TD>
		<TD>  $contactlist_subject </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Partners: </B></TD>
		<TD> $contactlist_partners </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Date Created: </B></TD>
		<TD> $contactlist_date </TD>
		</TR>
		</TABLE> |;


# List all notes:

    } else {

	$table_title = 'Sales Contact Lists';

	@table_headers = ( qq|<A HREF="$thisscript">Date Created</A>|,
			   qq|<A HREF="$thisscript?sortby=owner">Owner</A>|,
			   qq|<A HREF="$thisscript?sortby=name">List Name</A>| );


	foreach $tmp_key ( reverse sort keys %sort_list ) {

	    &getInfo( $tmp_key );

	    $table_data .= join "\t", ( $contactlist_date,
					$tmp_contactlist_owner,
					qq|<A HREF="$thisscript?contactlist_id=$contactlist_id">$contactlist_subject</A>| . "\n" );

	}

	&makeTable('HTML');
	$page_contents = $table_contents;

    } # list all



# Print output web page

    &printWebpage; 

}



# Retrieve the note given the note ID:

sub getInfo {

    my $tmp_key = shift;

    ( $contactlist_id,
      $contactlist_owner,
      $contactlist_partners,
      $contactlist_subject,
      $upload_filename ) = split /\t/, $sort_list{ $tmp_key };

    # $messages .= "DEBUG: Note = $sort_list{ $tmp_key } <BR>\n";

    $contactlist_date      = localtime( $contactlist_id );
    $tmp_contactlist_owner = $ad_system_users{ $contactlist_owner }->{'name'} || $contactlist_owner;

    return 1;

} # sub getInfo






__END__
