#!/usr/bin/perl


# This CGI script is a public page showing all current ad campaigns
# and is useful as a lead-in menu page for advertising client to get to their
# ad reports.
#
# Notes:
#	- Removed adlib.pl dependancy
#	- adinfo.dat changed to ad_info.dat
#	- prettier presentation
#	- displays HTML ads
#
#
# Modified:  Kurt -- Fri Sep 10 10:56:26 EDT 1999
#
#            Tomas                Y2K passed 11/05/99
#
#            Tomas -- 11/16/99 : CGI.pm instead of cgi-lib.pl made strict compliant
#                                 Made overall Perl5 compliant
#                                 added <input type="hidden" name="verify_access" value="on"> 
#                                 so rp_ad.pl knows when called from rp_current_ads.pl
#            
#            Kurt Gray -- Fri Nov 10 15:48:45 EST 2000      Code cleanup; Changed adcomp.dat -> ad_campaigns_info.dat
#            Kurt Gray -- Thu Jan 18 10:50:29 EST 2001      Changed loging form to point to new adsystem:ad_report.pl
#            Kurt Gray -- Fri Feb 16 16:53:18 EST 2001      Fixed StartDate and StopDate input in login form


use Date::Manip;
push @INC, '/usr/local/adsystem/lib/';
require 'ad_config_lib.pl';


# Get modified datestamp on ad_info.dat

    my $ad_campaign_infofile    = $adcompfile;
    my $scripturl               = $ENV{'SCRIPT_NAME'};
    my $datfilepath             = '/usr/local/adsystem/dat';
    my $adinfofile              = "$datfilepath/ad_info.dat";
    my $logdate                 = &Date::Manip::UnixDate("today", '%y%m%d');
    my $adlogfile               = '/usr/local/adsystem/logs/ads_' . $logdate . '.log';
    my $todaydate               = &Date::Manip::UnixDate("today", '%m/%d/%y');
    my $yesterdaydate           = &Date::Manip::UnixDate("yesterday", '%m/%d/%y');

    $list_all_campaigns = 0;    # Set to 1 to display gallery of all current ads


# Read inputs:

    my $ad_campaign = $1 if $ENV{'QUERY_STRING'} =~ /adcamp=(\w{2,8})/;
    $ad_campaign ||= $1 if $ARGV[0] =~ /adcamp=(\w{2,8})/;


# Make list of ad_campaigns

    if ( open PASSFILE, "< $ad_campaign_infofile" ) {
	while (<PASSFILE>) {
	    ($tmp_campaign, $tmp_campaign_name, undef) = split /\t/, $_;
	    $campaigns_list{$tmp_campaign} = $tmp_campaign_name;
	    $number_of_campaigns++;
	}
	close PASSFILE;
    } else {
	$error_messages .= "ERROR: Couldn't open $ad_campaign_infofile : $! <P>\n";
    }


# Make list of sites where the given ad campaign ran today

    if ( $ad_campaign =~ /\w+/ ) {

	$ad_campaign_name = $campaigns_list{$ad_campaign};

	if ( open LOGFILE, "< $adlogfile" ) {
	    while (<LOGFILE>) {
		chomp;
		($adid,$impressions,$clicks,$siteid) = split /\t/;
		next if $adid !~ /^$ad_campaign/;
		$todays_sites{$adid} .= ' ' . $sitesconfig{ $siteid . 'sitename' };
	    }
	    close LOGFILE;
	} else {
	    $error_messages .= "ERROR: Unable to read today's ad stats show not sure which sites these ads are running on now.<BR>";
	}


# Print all ads for requested advertiser

	my $infofile_mod_date   = localtime ( (stat($adinfofile))[9] );

	if ( open ADINFOFILE, "< $adinfofile" ) {
	    while (<ADINFOFILE>) {
		($adid,$ht,$wh,$target_url,$alt_text,$vendors_name) = split(/\t/,$_);
	    
		next if $adid !~ /^$ad_campaign/;

		if (substr($adid,4,1) eq '5') {
		    $htmldata = 'ad' . $adid . '.dat';
		    if ( open ADFILE, "../htdocs/htmlad/$htmldata" ) {
			while (<ADFILE>) {
			    $list_of_ads .= $_;
		    }
			close ADFILE;
		    } else {
			$error_messages .= "Can not read ../htdocs/htmlad/$htmldata : $! <P>\n";
		    }
		} else {
		    $list_of_ads .= "<BR><A HREF=\"$target_url\">";
		    $list_of_ads .= "<IMG SRC=\"/banner/$adid\.gif\" ALT=\"$alt_text\"></A>\n";
		}
		
		$list_of_ads .="<BR> <B>Banner ID: </B>$vendors_name ($adid)\n";
		$list_of_ads .="<BR> <B>Target URL: </B><A HREF=\"$target_url\">$target_url</A>\n";
		$list_of_ads .="<BR> <B>Alt Text: </B><I>$alt_text</I>\n";
		if (  $todays_sites{$adid} ) {
		    $list_of_ads .="<BR> <B>Currently running on: </B> " . $todays_sites{$adid} . "<P>\n";
		} else {
		    $list_of_ads .="<BR>This banner ($adid) is not currently running on any of our sites today.<P> \n";
		}
		$number_of_ads++;
	    }
	    
	    close ADINFOFILE;
	} else {
	    $error_messages .= "ERROR: Can not list ads for $ad_campaign_name: Can not read ad_info.dat: $! <P>\n"; 
	}

	if ( $number_of_ads < 1 ) {
	$list_of_ads = "<P>No ads for $ad_campaign are in the current network rotation.\n"; 
    }
	

	$page_contents =<<LIST_OF_ADS;

	<FONT SIZE=+1 COLOR=RED><I><B>OSDN Network: List of Ads by Campaign</B></I></FONT>
    &nbsp; [<A HREF="http://www.osdn.com/">OSDN Home</A>] 
    &nbsp; [<A HREF="$scripturl?adcamp=$ad_campaign#login">$ad_campaign_name Ad Stats</A>]
    &nbsp; [<A HREF="$scripturl">List Current Sponsors</A>]
        <BR>
        $error_messages
        <BR>

	Ad Info Updated: $infofile_mod_date
       <BR>

    $list_of_ads

LIST_OF_ADS


# No ad_campaign input: List all ad campaigns

    } else {

	my $list_mod_date = localtime ( (stat($ad_campaign_infofile))[9] );
    
	# Sort campaigns list alphabetically

	$number_of_page_columns = 3;
	$lines_per_page_column = int ( $number_of_campaigns / $number_of_page_columns );

	for $ad_campaign (sort keys %campaigns_list) {
	    $line_number++;
	    $advertiser_list .= "<A HREF=\"$scripturl?adcamp=$ad_campaign\">" . $campaigns_list{$ad_campaign} . "</A><BR>\n";
	    $advertiser_list .= "</TD><TD>" if ( $line_number % $lines_per_page_column ) < 1;
	}
	
	$page_contents .= qq|

<FONT SIZE=+1 COLOR=RED><B><I>Network Ad System:</FONT></I></B>
<P>
$error_messages
<P>

    |;

	$page_contents .= qq|

Campaign List Last Updated: $list_mod_date

<P>

Click on a campaign name to view current ads:

<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=15>
<TR>
<TD>
$advertiser_list
</TR>
</TABLE>

    | if $list_all_campaigns == 1;


} # if ad_campaign



# Print output web page

     print "Content-type: text/html\n\n";

     print <<WEB_PAGE;

<HTML>
<HEAD><TITLE>Network Ad System</TITLE></HEAD>
<BODY bgcolor="#FFFFFF" link="#000099" vlink="#000099">

    <FONT FACE=ARIAL,HELVETICA>
    <BLOCKQUOTE>

$page_contents

    <A NAME="login">

        <FORM METHOD="POST" ACTION="$ad_report_url"> 

	<TABLE BORDER=0 BGCOLOR="#EEEEEE" WIDTH=500 CELLPADDING=4>
	<TR BGCOLOR="#CCCC99">
	<TD COLSPAN=2>
	&nbsp; &nbsp;
	<FONT FACE=ARIAL,HELVETICA SIZE=3>
	<B>$ad_campaign_name Campaign Stats Login:</B>
	</FONT>
	</TD>
	</TR>
	<TR>
	<TD>
	<FONT FACE=ARIAL,HELVETICA SIZE=3>
	Username: 
	</TD>
	<TD WIDTH=370>
	<INPUT SIZE=6 NAME="UserName" VALUE="$ad_campaign">
	</TD>
	</TR>
	<TR>
	<TD>
	<FONT FACE=ARIAL,HELVETICA SIZE=3>
	Password: 
	</TD>
	<TD>
	<INPUT SIZE=6 TYPE="PASSWORD" NAME="Password">
	</TD>
	</TR>
	<TR>
	<TD>
	<FONT FACE=ARIAL,HELVETICA SIZE=3>
	Date Range: 
	</TD>
	<TD>
	<INPUT SIZE=8 NAME="StartDate" VALUE="$yesterdaydate"> &nbsp; to &nbsp; <INPUT SIZE=8 NAME="StopDate" VALUE="$todaydate">
	&nbsp; (mm/dd/yy)
	</TD>
	</TR>
	<TR>
	<TD COLSPAN=2>	
        <FONT FACE=ARIAL,HELVETICA SIZE=3>
	</TD>
	</TR>
	<TR>
	<TD COLSPAN=2>
	<INPUT TYPE="SUBMIT" VALUE="Show Stats">
	</FORM>
	</TABLE>
	<P>
	<BR>

    </BLOCKQUOTE>
    </FONT>

</BODY>
</HTML>

WEB_PAGE







__END__
























