#!/usr/bin/perl

#
# This is a CGI interface for browsing, creating, and editing notes
#
# Notes: 
#
#
# Modified:  Kurt Gray -- Fri Jan  5 12:24:19 EST 2001      First rev. hacked out of ad_compedit.pl

push @INC, '/usr/local/adsystem/lib/';
require 'ad_config_lib.pl';	        # Site-specific settings for adsystem control scripts
require 'ad_util_lib.pl';	        # Common functions for adsystem scripts
require 'ad_email_lib.pl';

{

# Script settings and base inputs:

    $thisscript           ||= $ENV{'SCRIPT_NAME'};


# Print top of output web page and check user login

    &loginUser( $editorial_staff );

    %note_types =     ( 'DONE',    'DONE',
			'TODO',    'TODO Entry',
			'BUG',     'BUG Report',
			'CHANGE',  'CHANGE Request',
			'ADD',     'ADD Request',
			'NOTE',    'NOTE to self',
			'HELP',    'HELP Question',
			'INFO',    'INFO blurb',
			'COMMENT', 'COMMENT' );
    

    %note_contexts =  ( 'AdSystem',    'Ad System',
		        'Stats',       'Stats',
		        'General',     'General',
		        'FAQ',         'FAQ topic',
			'RFP',         'RFP topic' );


    %email_frequencies = ( 'EmailAtNever',     'Never',
			   'EmailNow',         'Right Now',
			   'EmailDaily',       'Everyday',
			   'EmailMonthly',     'On the last day of every month',
			   'EmailWeekly1Mon',  'Every week on Monday',
			   'EmailWeekly2Tue',  'Every week on Tuesday',
			   'EmailWeekly3Wed',  'Every week on Wednesday',
			   'EmailWeekly4Thu',  'Every week on Thursday',
			   'EmailWeekly5Fri',  'Every week on Friday',
			   'EmailOnDate',      'On the date specified...' );


# Read form inputs:

    $note_id_in          = $1 if $form->{'in'}->{'note_id'} =~ /(\d+)/;

    $op                  = $1 if $form->{'in'}->{'op'} =~ /(\w+)/;
    $op                ||= 'view' if $note_id_in;
    $function            = 'save' if $form->{'in'}->{'GoButton'} =~ /Save/;
    $sortby              = $1 if $form->{'in'}->{'sortby'} =~ /(\w+)/;

    $note_context_in     = $1 if $form->{'in'}->{'context'} =~ /([\w\.\-]+)$/;
    $note_subject_in     = $form->{'in'}->{'subject'};
    $note_type_in        = $1 if $form->{'in'}->{'note_type'} =~ /(\w+)/;
    $note_parentid_in    = $1 if $form->{'in'}->{'note_parentid'} =~ /(\d+)/;
    $note_author_in      = $1 if $form->{'in'}->{'author'} =~ /(\w+)/;


    $nav_links->{ $sales_dept }->{ "Add a $note_context_in Entry" } = qq|$thisscript?op=edit&context=$note_context_in&note_type=INFO| if $note_context_in && $op ne 'edit';


# Save note:

    if ( $function eq 'save' ) {

	$note_id         = $note_id_in || time;
	$note_context    = $note_context_in || 'General';
	$note_parentid   = $note_parentid_in;
	$note_type       = $note_type_in;
	$note_kill       = $form->{'in'}->{'note_kill'};
	$note_type       = $form->{'in'}->{'note_type'};
	$note_private    = $form->{'in'}->{'note_private'};
	$note_subject    = $form->{'in'}->{'note_subject'};
	$note_message    = $form->{'in'}->{'note_message'};
	$note_emailat    = $form->{'in'}->{'note_emailat'};
	$note_emaildate  = $form->{'in'}->{'note_emaildate'};
	$note_emailcc    = $form->{'in'}->{'note_emailcc'};
	$upload_filename = $1 if $form->{'in'}->{'upfile'}->{'filename'} =~ /([\w\.\-\ ]+)$/;
	$upload_filename =~ s/\s+/_/g;

	# $note_private = 'PRIVATE' if $note_type eq 'NOTE'; # Notes are 'NOTE to self' therefore private

	if ( $note_kill eq 'T' ) {
	    $messages .= "NOTICE: Entry removed : $note_id $note_type $note_subject <BR>";
	    $ignoring_input++;
	    $op = 'listall';
	    # TODO: Delete message file and attachment file too
	}

	if ( ( $note_subject !~ /\w+/ ) && ( $note_message !~ /\w+/ ) ) {
	    $error_messages .= "INPUT ERROR: Not saving note: Subject and message body is empty. <BR>";
	    $dontsaveinput++;
	    $op = 'edit';
	}

	push @replaced_notes, $note_id;

	# Save the note:

	if ( ! $ignoring_input ) {

	    if ( $upload_filename ) {
		$upload_filepath = "$notes_uploadpath/$upload_filename";
		my $upload_filedata = $form->{'in'}->{'upfile'}->{'value'};
	        $upload_filedata =~ s/\<\!//g;     # Strip SSI tags from file contents
	        $upload_filedata =~ s/\-\-\>//g;
		if ( open ( UPFILE, "> $upload_filepath") ) {
		    binmode UPFILE;
		    print UPFILE $upload_filedata;
		    close UPFILE;
		    $messages .= "NOTICE: File attachment saved: $upload_filename <BR>\n"; 
		} else {
		    $error_messages .= "ERROR: Could not store upload file $upload_filename: $! ";
		    $upload_filename = '';
		}
	    } else {

		# Reserve previous file attachment except on replies:
		$upload_filename = $1 if ( $form->{'in'}->{'previous_attachment'} =~ /([\w\.\-]+)/ ) && ( ! $note_parentid );

	    } # if upload_filename


	    if ( $note_message =~ /\w+/ ) {
		$note_message_filepath = "$notes_messagepath/$note_id.txt";
		if ( open ( OUTFILE, "> $note_message_filepath") ) {
		    print OUTFILE $note_message;
		    close OUTFILE;
		} else {
		    $error_messages .= "ERROR: Could not store note message body $note_message_filepath : $! ";
		}
	    } # message body


	    # User entered a specific alert date:
	    
	    if ( $note_emaildate ) {
		$note_emailat = &NiceDate2ISODate( $note_emaildate );
	    } elsif ( $note_emailat eq 'EmailAtNever' ) {
		$note_emailat = '';
	    } elsif ( $note_emailat eq 'EmailNow' ) {
		$from_addr       = $ad_system_users{$username}->{'email'} || $email_admin;
		$to_addr         = $ad_system_users{$username}->{'email'};
		$to_addr        .= ",$note_emailcc" if $note_emailcc;
		$email_subject   = "$email_subject_prefix NOTE: $note_subject";
		$tmp_attachment_link = $upload_filename ? 
		    qq|Attachment: $system_baseurl$notes_uploadbaseurl/$upload_filename| : '';
		$email_message   = qq|$note_message\n\n$tmp_attachment_link\nPosted at: $system_baseurl$ad_notes_url?note_id=$note_id\n|;
		&SendEmail;
		$note_emailat = '';
	    }


	    $new_file_data .= join "\t", ( $note_id,
					   $note_parentid,
					   $note_context,
					   $note_type,
					   $note_private,
					   $username,
					   $note_subject,
					   $note_emailat,
					   $note_emailcc,
					   $upload_filename,
					   "\n");
	    
	} # if note_kill
	
    } # if Save


# Read all notes data on file, replace overwritten data, append new input data to it, 

    $file_data = $new_file_data;

    if ( open( INFILE, "< $notes_idxfile" ) ) { 
	while ( $line = <INFILE>) {
	    next if $line !~ /(\d+)\t/;
	    next if grep /$1/, @replaced_notes;  # Skip over deleted or edited campaign records
	    $file_data .= $line;
	}
	close INFILE;
    } else {
	$error_messages .= "ERROR: Could not read notes index file $notes_idxfile : $! <BR>\n";
    }


# Save new idx file:

    if (( $function eq 'save' ) && ( ! $dontsaveinput )) {

	# TODO: Don't allow users to overwrite each other's notes

	if ( $user_access_level < $editorial_staff ) {
	    $error_messages .= "ERROR: Can not save file: User $username does not have write privileges to this interface. <BR>\n"; 
	} else {
	    &BackupAndSaveFile( "$notes_idxfile" );
	}

    } # if save changes



# Read all data into a sortable hash:

    foreach $line ( ( split /\n/, $file_data ) ) {
	
	( $tmp_note_id,
	  $tmp_note_parentid,
	  $tmp_note_context,
	  $tmp_note_type,
	  $tmp_note_private,
	  $tmp_username,
	  $tmp_note_subject,
	  $tmp_note_emailat,
	  $tmp_note_emailcc,
	  $tmp_upload_filename ) = split /\t/, $line;

	# $sortby ||= 'subject';

	# Don't show private notes:
	next if ( $tmp_note_private eq 'PRIVATE' ) && ( $tmp_username ne $username );

	# Only show notes of given context if context is specified:
	next if ( $note_context_in ) && ( $tmp_note_context ne $note_context_in );

	# Only show notes of given username if author is specified:
	next if ( $note_author_in ) && ( $tmp_username ne $note_author_in );

	if ( $sortby eq 'username' ) {
	    $tmp_key = $tmp_username . "z$tmp_note_id";
	} elsif ( $sortby eq 'type' ) {
	    $tmp_key = $tmp_note_type . "z$tmp_note_id";
	} elsif ( $sortby eq 'subject' ) {
	    $tmp_key = $tmp_note_subject . "z$tmp_note_id";
	} elsif ( $sortby eq 'context' ) {
	    $tmp_key = $tmp_note_context . "z$tmp_note_id";
	} elsif ( $sortby eq 'attachment' ) {
	    $tmp_key = $tmp_upload_filename . "z$tmp_note_id";
	} else {
	    $tmp_key = $tmp_note_id;
	} #if sortby

	$notes_list{ $tmp_key } = $line;

    } # foreach data_file line



# Make an HTML edit form for the given note:

    if ( $op eq 'edit' ) {

	&getNoteInfo( $note_id_in || $note_parentid_in );
 
	$page_title = qq|Editing $note_type $note_subject: |;

	( $tmp_user_id, $tmp_username ) = () if $note_parentid_in;
	if ( ( $tmp_user_id ) && ( $username ne $tmp_user_id )) {
	    print "SORRY: Users are not allowed to edit notes from other users. <BR>";
	    exit;
	}

	$note_id         = '' if $note_parentid_in;
	$note_parentid   = $note_parentid_in || $note_parentid;
	$tmp_username  ||= $ad_system_users{ $username }->{'name'} || $username;
	# $note_type       = $note_type_in if $note_parentid_in;
	$note_type     ||= 'NOTE';
	$note_private  ||= $note_type eq 'NOTE' ? 'PRIVATE' : 'PUBLIC';
	$note_context  ||= $note_context_in;
	$note_subject  ||= $note_subject_in;
	$note_subject    = qq|Re: $note_subject| if ( ( $note_parentid_in ) && ( $note_subject !~ /Re: /));
	$note_emailat    = '' if $note_parentid_in;
	$note_emailcc    = '' if $note_parentid_in;

	$page_contents .= qq|<FORM METHOD=POST ENCTYPE='multipart/form-data' ACTION=$thisscript?op=edit>
	        <TABLE BGCOLOR=WHITE>
	        <TR BGCOLOR=DDFFCC>   
		<TD ALIGN=RIGHT><B>Posted By:</B></TD><TD> $tmp_username </TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD ALIGN=RIGHT><B>Context:</B></TD><TD> |;

	%drop_list = %note_contexts;
	&makeDropList( 'context', $note_context || 'General' );

	$page_contents .= qq| &nbsp; <B>Message Type:</B> |;
	%drop_list = %note_types;
	&makeDropList( 'note_type', $note_type_in || $note_type );

	$page_contents .= qq| </TD>
	         </TR><TR>
                 <TD ALIGN=RIGHT><B>Subject:</B></TD><TD>
		     <INPUT NAME="note_subject" SIZE="40" MAXLENGTH="50" VALUE="$note_subject"></TD>
                 </TR><TR BGCOLOR=DDFFCC>
                 <TD ALIGN=RIGHT><B>Attachment:</B></TD><TD> $tmp_attachment_link <INPUT TYPE=FILE NAME=upfile></TD>
                 </TR><TR BGCOLOR=DDFFCC>
		 <TD ALIGN=RIGHT VALIGN=TOP><B>Message:</B></TD>
		     <TD><TEXTAREA WRAP=OFF ROWS=12 COLS=49 NAME="note_message">$note_message</TEXTAREA></TD>
		 </TR><TR BGCOLOR=FFFFCC><TD ALIGN=RIGHT> <B>Access:</B> </TD><TD>|;

	%drop_list = ( 'PRIVATE', 'Private: only you can read this note',
		       'PUBLIC',  'Public: all ad system users can read this note' );
	&makeDropList( 'note_private', $note_private );

	$page_contents .= qq|</TD></TR><TR><TD ALIGN=RIGHT><B>Email Reminder:</B></TD><TD>|;

	%drop_list = %email_frequencies;
	&makeDropList ( 'note_emailat', $note_emailat || 'EmailAtNever' );
			
	$page_contents .= qq| &nbsp; 
	        <B>Date:</B> <INPUT TYPE="TEXT" SIZE=12 MAXLENGTH=12 NAME="note_emaildate" VALUE="$note_emaildate"></TD>
		 </TR><TR>
                 <TD ALIGN=RIGHT><B>Email CC:</B></TD><TD>
		     <INPUT NAME="note_emailcc" SIZE="40" MAXLENGTH="50" VALUE="$note_emailcc"></TD>
		</TR><TR BGCOLOR=\#AAAAFF>
		<TD>
		    <INPUT TYPE="HIDDEN" NAME="previous_attachment" VALUE="$upload_filename">
		    <INPUT TYPE="HIDDEN" NAME="note_id" VALUE="$note_id">
		    <INPUT TYPE="HIDDEN" NAME="note_parentid" VALUE="$note_parentid">
		    <INPUT TYPE="CHECKBOX" NAME="note_kill" VALUE="T"> Delete this note </TD>
		<TD>
		    <INPUT TYPE="SUBMIT" NAME=GoButton VALUE="Save Note"></TD>
		</TR>
		</TABLE>
	    </FORM>
		|;


# View the note:
	
    } elsif ( $op eq 'view' ) {

	&getNoteInfo( $note_id_in );

	$edit_link = qq|<A HREF="$thisscript?op=edit&note_id=$note_id_in">Edit this note</A>| if $username eq $tmp_user_id;
	$reply_link = qq|<A HREF="$thisscript?op=edit&note_parentid=$note_id&context=$note_context&note_type=REPLY">Reply to this note</A>|;

	$note_message =~ s/\n/<BR>/g;
	$tmp_date = localtime( $note_id );

	$tmp_attachment_row = qq|<TD ALIGN=RIGHT><B> Attachment:</B></TD>
		<TD> $tmp_attachment_link </TD>
		</TR><TR>| if $upload_filename;

	$page_contents .= qq|

		<TABLE BGCOLOR=WHITE CELLPADDING=5>
		<TR>
		<TD> </TD>
		<TD ALIGN=MIDDLE BGCOLOR=DDDDDD> $edit_link </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Posted By:</B></TD>
		<TD> $tmp_username &nbsp; $tmp_date </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Status:</B></TD>
		<TD>  $note_type [$note_private] </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Context:</B></TD>
		<TD> $note_context </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Subject:</B></TD>
		<TD> $note_subject </TD>
		</TR><TR>
		$tmp_attachment_row
		<TD ALIGN=RIGHT VALIGN=TOP><B> Message:</B></TD>
		<TD> $note_message </TD>
		</TR> <TR>
		<TD> </TD>
		<TD ALIGN=MIDDLE BGCOLOR=DDDDDD> $reply_link </TD>
		</TR>
		</TABLE> |;


# List all notes:

    } else {

	@table_headers = ( qq|<A HREF="$thisscript">Date</A>|,
			   qq|<A HREF="$thisscript?sortby=username">Posted By</A>|,
			   qq|<A HREF="$thisscript?sortby=context">Context</A>|,
			   qq|<A HREF="$thisscript?sortby=type">Status</A>|,
			   qq|<A HREF="$thisscript?sortby=subject">Subject</A>|,
			   qq|<A HREF="$thisscript?sortby=attachment">Attachment</A>| );

	foreach $tmp_key ( reverse sort keys %notes_list ) {

	    &getNoteInfo( $tmp_key );

	    $tmp_note_private = $note_private eq 'PRIVATE' ? '[PRIVATE]' : '';

	    $table_data .= join "\t", ( $note_date,
					$tmp_username,
					qq|<A HREF="$thisscript?context=$note_context">$note_context</A>|,
					$note_type,
					qq|$tmp_note_private <A HREF="$thisscript?note_id=$note_id">$note_subject</A>|,
					$tmp_attachment_link,
					"\n");

	} # foreach ad_campaign


	$table_title = 'OSDN Ad System Notes';

	&makeTable('HTML');
	$page_contents = $table_contents;


    } # list all ad_campaigns




# Print output web page

    &printWebpage; 

}



# Retrieve the note given the note ID:

sub getNoteInfo {

    my $tmp_key = shift;

    ( $note_id,
      $note_parentid,
      $note_context,
      $note_type,
      $note_private,
      $tmp_username,
      $note_subject,
      $note_emailat,
      $note_emailcc,
      $upload_filename ) = split /\t/, $notes_list{ $tmp_key };

    # $messages .= "DEBUG: Note = $notes_list{ $tmp_key } <BR>\n";

    $note_date             = localtime( $note_id );
    $tmp_user_id           = $tmp_username;
    $tmp_username          = $ad_system_users{ $tmp_username }->{'name'} || $tmp_username;
    $tmp_attachment_link   = $upload_filename ? qq|<A HREF="$notes_uploadbaseurl/$upload_filename">$upload_filename</A>| : '';
    $note_message_filepath = "$notes_messagepath/$note_id.txt";
    $note_message          = &ReadFile( $note_message_filepath ) if ( $note_id_in && ( -f $note_message_filepath ));

    return 1;

} # sub getCampaignInfo






__END__
