#!/usr/bin/perl

#
# This is a CGI interface for editing ad system user info
#
# Notes: 
#
#
# Modified:  Kurt Gray -- Tue Jan  9 14:23:10 EST 2001      First rev. hacked out of ad_notes.pl

push @INC, '/usr/local/adsystem/lib/';
require 'ad_config_lib.pl';	# Site-specific settings for adsystem control scripts
require 'ad_util_lib.pl';	# Common functions for adsystem scripts
require 'ad_email_lib.pl';	# Send email functions

{

# Script settings and base inputs:

    $thisscript           ||= $ENV{'SCRIPT_NAME'};

    $nav_links->{ $super_admin_access }->{'Create New User'}    =  "$thisscript?op=edit";


# Print top of output web page and check user login

    &loginUser( $partner_access );

    &getActiveSitenames;    # sets %sitenames hash to render sites checkboxes for each run
    $sitenames{ 'Andover: Run Of Network' } ||= 'atronen';
    $sitenames{ 'OSDN: Run Of Network' }    ||= 'osronen';


    %tmp_access_types = ( 'PARTNERSHIP',    'PARTNERSHIP',
			  'EDITOR',         'EDITOR',
			  'WEBDEV',         'WEBDEV',
			  'MARKETING',      'MARKETING',
			  'ACCOUNTING',     'ACCOUNTING',
			  'FINANCE',        'FINANCE',
			  'TRAFFIC_AUDIT',  'TRAFFIC_AUDIT',
			  'DIRECTOR',       'DIRECTOR',
			  'BIZDEV',         'BIZDEV',
			  'SITE_DIRECTOR',  'SITE_DIRECTOR',
			  'SALES',          'SALES',
			  'SALES_MANAGER',  'SALES_MANAGER',
			  'ADMIN',          'ADMIN',
			  'TECH_ADMIN',     'TECH_ADMIN',
			  'SUPER_ADMIN',    'SUPER_ADMIN' );


# Read form inputs:

    $user_id_in          = $1 if $form->{'in'}->{'user_id'} =~ /(\w{1,20})/;
    $op                  = $1 if $form->{'in'}->{'op'} =~ /(\w+)/;
    $op                ||= 'view' if $user_id_in;
    $op                  = 'edit' if $username eq $user_id_in;
    $function            = 'save' if $form->{'in'}->{'GoButton'} =~ /Save/;
    $sortby              = $1 if $form->{'in'}->{'sortby'} =~ /(\w+)/;

    if ( $function eq 'save' ) {

	$user_id                 = $user_id_in;
	$user_kill               = $form->{'in'}->{'user_kill'};
	$user_password           = $1 if $form->{'in'}->{'user_password'}          =~ /(\S{4,12})/;
	$user_password_confirm   = $1 if $form->{'in'}->{'user_password_confirm'}  =~ /(\S{4,12})/;
	$user_access_type        = $1 if $form->{'in'}->{'user_access_type'}       =~ /(\w{2,20})/;
	$user_name               = $form->{'in'}->{'user_name'};
	$user_email              = $1 if $form->{'in'}->{'user_email'} =~ /([^\/\;\:\*\&\^\%\$\#\!\~\+\{\[\(\?\"\']+)/;
	$user_email              =~ s/\s+//g;
	$user_status             = $1 if $form->{'in'}->{'user_status'} =~ /(\w{2,20})/;

	if ( $user_password !~ /\w+/ ) {
	    print "INPUT ERROR: Password input was blank: Must be at least 4 characters.<BR>";
	    exit;
	}

	if ( $user_access_level < $super_admin_access ) {

	    if ( $username ne $user_id ) {
		print "ERROR: User $username can not overwrite other user's account info. <BR>\n";
		exit;
	    }

	    ( $user_id, 
	      $user_access_type,
	      $user_siteids,
	      $user_status ) = ( $username,
				 $ad_system_users{ $username }->{'access_type'},
				 $ad_system_users{ $username }->{'siteids'},
				 $ad_system_users{ $username }->{'status'} );

	} else {

	    if ( $user_kill eq 'T' ) {
		$messages .= "NOTICE: Entry removed : $user_id $user_name <BR>";
		$ignoring_input++;
		$op = 'listall';
	    }

	    if ( $user_id !~ /\w+/ ) {
		$error_messages .= "INPUT ERROR: Not saving user: Username input is blank. <BR>";
		$dontsaveinput++;
		$op = 'edit';
	    }

	    # Read siteids checkboxes:

	    @tmp_checkeditems  =  ();
	    for $i ( 1..(keys %sitenames) ) {
		push ( @tmp_checkeditems, $1 ) if $form->{'in'}->{ "user_siteids\_$i" } =~ /(\w+)/;
	    }
	    $user_siteids = join ',', @tmp_checkeditems;

	} # if super_admin

	push @replaced_users, $user_id;

	# Save the note:

	if ( ! $ignoring_input ) {

	    $new_file_data .= join "\t", ( $user_id, 
					   $user_password,
					   $user_access_type,
					   $user_name,
					   $user_email,
					   $user_siteids,
					   $user_status,
					   "\n");

	    
	} # if user_kill
	
    } # if Save


# Read all notes data on file, replace overwritten data, append new input data to it, 

    $file_data = $new_file_data;

    if ( open( INFILE, "< $adusersfile" ) ) { 
	while ( $line = <INFILE>) {
	    next if $line !~ /(\w+)\t/;
	    next if grep /$1/, @replaced_users;  # Skip over deleted or edited campaign records
	    $file_data .= $line;
	}
	close INFILE;
    } else {
	$error_messages .= "ERROR: Could not read users file $adusersfile : $! <BR>\n";
    }


# Save new idx file:

    if (( $function eq 'save' ) && ( ! $dontsaveinput )) {

	# TODO: Don't allow users to overwrite each other's notes

	if ( $user_access_level < $editorial_staff ) {
	    $error_messages .= "ERROR: Can not save file: User $username does not have write privileges to this interface. <BR>\n"; 
	} else {
	    &BackupAndSaveFile( "$adusersfile" );
	}

    } # if save changes



# Read all data into a sortable hash:

    foreach $line ( ( split /\n/, $file_data ) ) {
	
	( $tmp_username, 
	  $tmp_password,
	  $tmp_access_type,
	  $tmp_name,
	  $tmp_email,
	  $tmp_siteids,
	  $tmp_status ) = split /\t/, $line;

	if ( $sortby eq 'name' ) {
	    $tmp_key = $tmp_name . "z$tmp_username";
	} elsif ( $sortby eq 'id' ) {
	    $tmp_key = $tmp_username;
	} elsif ( $sortby eq 'group' ) {
	    $tmp_key = $tmp_access_type . "z$tmp_username";
	} elsif ( $sortby eq 'sites' ) {
	    $tmp_key = $tmp_siteids . "z$tmp_username";
	} elsif ( $sortby eq 'status' ) {
	    $tmp_key = $tmp_status . "z$tmp_username";
	} else {
	    $tmp_key = $tmp_username;
	} #if sortby

	$sort_list{ $tmp_key } = $line;

    } # foreach data_file line



# Make an HTML edit form for the given note:

    if ( $op eq 'edit' ) {

	&getInfo( $user_id_in );
 
	$page_title = qq|Editing $user_name Account Info: |;

	if ( $user_access_level < $super_admin_access ) {
	    if ( $username ne $user_id ) {
		print "SORRY: Users are not allowed to edit each other's account info. <BR>";
		exit;
	    }

	    $page_contents .= qq|<FORM METHOD=POST ACTION=$thisscript?op=edit>
	        <TABLE BGCOLOR=WHITE>
	        <TR BGCOLOR=DDFFCC>   
		<TD ALIGN=RIGHT><B>Username:</B></TD><TD> $user_id [$user_access_type]
		    <INPUT TYPE="HIDDEN" NAME="user_id" VALUE="$user_id"> </TD>
		</TR><TR BGCOLOR=FFFFCC>
		<TD ALIGN=RIGHT><B>Real Name:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_name" SIZE="30" MAXLENGTH="40" VALUE="$user_name"> </TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD ALIGN=RIGHT><B>Email:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_email" SIZE="30" MAXLENGTH="60" VALUE="$user_email"></TD>
		</TR><TR BGCOLOR=FFFFCC>
		<TD ALIGN=RIGHT><B>Password:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_password" SIZE="10" MAXLENGTH="12" VALUE="$user_password"></TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD></TD><TD>
		    <INPUT TYPE="SUBMIT" NAME=GoButton VALUE="Save Account Info"></TD>
		</TR>
		</TABLE>
	    </FORM>|;

	} else {

	    $user_access_type ||= 'WEBDEV';
	    $user_status      ||= 'ACTIVE';
	    $user_password    ||= &makeRandomPassword;

	    $page_contents .= qq|<FORM METHOD=POST ACTION=$thisscript?op=edit>
	        <TABLE BGCOLOR=WHITE>
	        <TR BGCOLOR=DDFFCC>   
		<TD ALIGN=RIGHT><B>Username:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_id" SIZE="12" MAXLENGTH="20" VALUE="$user_id"> </TD>
		</TR><TR BGCOLOR=FFFFCC>
		<TD ALIGN=RIGHT><B>Real Name:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_name" SIZE="30" MAXLENGTH="40" VALUE="$user_name"> </TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD ALIGN=RIGHT><B>Email:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_email" SIZE="30" MAXLENGTH="60" VALUE="$user_email"></TD>
		</TR><TR BGCOLOR=FFFFCC>
		<TD ALIGN=RIGHT><B>Password:</B></TD><TD>
		    <INPUT TYPE="TEXT" NAME="user_password" SIZE="10" MAXLENGTH="12" VALUE="$user_password"></TD>
		</TR><TR BGCOLOR=DDFFCC>
		<TD ALIGN=RIGHT><B>Access Group:</B></TD><TD> |;

	    %drop_list = %tmp_access_types;
	    &makeDropList( 'user_access_type', $user_access_type );

	    $page_contents .= qq| &nbsp; <B>Account Status:</B> |;
	    %drop_list = ( 'ACTIVE',   'ACTIVE',
		       'DISABLED', 'DISABLED' );
	    &makeDropList( 'user_status', $user_status );

	    $page_contents .= qq| </TD>
	         </TR><TR>
		     <TD ALIGN=RIGHT><B>Sites:</B></TD><TD> |;

	    %drop_list = reverse %sitenames;  # Inverse sitenames hash: siteids <--> sitenames
	    &makeCheckboxes ( 'user_siteids', $user_siteids ); # Allowing multiple sites per user
			
	    $page_contents .= qq| &nbsp; 
	        </TD>
		    </TR><TR BGCOLOR=\#AAAAFF>
		<TD>
		    <INPUT TYPE="CHECKBOX" NAME="user_kill" VALUE="T"> Delete this account </TD>
		<TD>
		    <INPUT TYPE="SUBMIT" NAME=GoButton VALUE="Save Account Info"></TD>
		</TR>
		</TABLE>
	    </FORM>|;

	} # if super_user


# View the account info:
	
    } elsif ( $op eq 'view' ) {

	&getInfo( $user_id_in );

	$edit_link = qq| &nbsp; [<A HREF="$thisscript?op=emailpasswd&user_id=$user_id_in">Email Passwd</A>] | if ( $user_status eq 'ACTIVE' ) && ( $user_access_level == $super_admin_access);
	$edit_link .= qq| &nbsp; [<A HREF="$thisscript?op=edit&user_id=$user_id_in">Edit</A>] | if $user_access_level == $super_admin_access;

	$page_contents .= qq|

		<TABLE BGCOLOR=WHITE CELLPADDING=5>
		<TR>
		<TD> </TD>
		<TD ALIGN=MIDDLE BGCOLOR=DDDDDD> $edit_link </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> User ID: </B></TD>
		<TD> $user_id </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> User Name: </B></TD>
		<TD>  $user_name </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Email: </B></TD>
		<TD> <A HREF="mailto\:$user_email">$user_email</A> </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Group: </B></TD>
		<TD> $user_access_type </TD>
		</TR><TR>
		<TD ALIGN=RIGHT><B> Status: </B></TD>
		<TD> $user_status </TD>
		</TR>
		</TABLE> |;


# List all notes:

    } else {

        if ( $op eq 'emailpasswd' ) {
	    &getInfo( $user_id_in );
	    &sendAccountActivatedEmail;
	}


	$table_title = 'OSDN Ad System Users';

	@table_headers = ( qq|<A HREF="$thisscript?sortby=id">User ID</A>|,
			   qq|<A HREF="$thisscript?sortby=name">User Name</A>|,
			   qq|<A HREF="$thisscript?sortby=group">Group</A>| );

	foreach $tmp_key ( sort keys %sort_list ) {

	    &getInfo( $tmp_key );
	    
	    if (( $user_status eq 'ACTIVE' ) && ( $user_access_level == $super_admin_access )) {
		$mailpasswdlink = qq|<A HREF="$thisscript?op=emailpasswd&user_id=$user_id">Email Passwd</A>|;
	    } else {
		$mailpasswdlink = '';
	    }

	    $table_data .= join "\t", ( qq|<A HREF="$thisscript?user_id=$user_id">$user_id</A>|,
					qq|<A HREF="$thisscript?user_id=$user_id">$user_name</A>|,
					$user_access_type, "$mailpasswdlink\n");

	} # foreach ad_campaign

	&makeTable('HTML');
	$page_contents = $table_contents;

    } # op eq listall



# Print output web page

    &printWebpage; 

}



# Retrieve the note given the note ID:

sub getInfo {

    my $tmp_key = shift;

    ( $user_id,
      $user_password,
      $user_access_type,
      $user_name,
      $user_email,
      $user_siteids,
      $user_status ) = split /\t/, $sort_list{ $tmp_key };

    return 1;

} # sub getInfo






__END__
