
# OSDN adsystem per-site configuration file. This file should only 
# exists on the central adsystem control server.
# 
# Notes:
#          - Any unique per-site ad system behaviours should be configured in this file only.
#
#
# Modified:  Kurt Gray -- Tue Sep 26 13:51:44 EDT 2000     Added small ad height restriction for VA sites
#            Kurt Gray -- Tue Oct 10 18:49:29 EDT 2000     Added option to consolidate ad logs on NFS host
#            Kurt Gray -- Fri Oct 20 15:39:57 EDT 2000     Trying to host this all on report.andover.net
#            Kurt Gray -- Mon Oct 23 18:29:15 EDT 2000     Created %siteconfig array for each web site
#            Kurt Gray -- Mon Nov 20 12:49:04 EST 2000     sun00472 and ads.freshmeat.net now using rsync update method
#            Kurt Gray -- Tue Nov 28 10:38:26 EST 2000     Added Open Magazine; Added ad_newsletter settings
#            Kurt Gray -- Sun Dec  3 16:04:37 EST 2000     Added access_levels for advertisers and anonymous 
#            Kurt Gray -- Tue Dec  5 16:33:07 EST 2000     Rearranged Slashdot images server and ad log pickup 
#            Kurt Gray -- Fri Dec  8 15:26:17 EST 2000     Added Homestead.AnimFactory
#            Kurt Gray -- Thu Apr 19 14:26:42 EDT 2001     Several sites decommisioned; Added reserved_domains


    $debugging = 0;

    $testbed = 1 if $ENV{'SERVER_NAME'} eq 'kurtslap.andover.net';
    $testbed = 1 if $ENV{'HOSTNAME'} eq 'kurtslap';

    if ( $testbed == 1 ) {

	# $messages           .= '{TESTBED MODE} ';     
	# $force_login         = 'NO';
	$verify_gifs_exists   = 'NO';
	# $user_access_level   = 10;
	$weblogpath           = '/usr/local/apache/sites/kurt/logs';
	$notes_uploadpath     = '/usr/local/apache/sites/kurt/htdocs/uploads';
	$graph_basepath       = '/usr/local/apache/sites/kurt/htdocs/graphs';
	$ad_htmlad_path       = '/usr/local/apache/sites/kurt/htdocs/htmlad';
	$ad_banner_path       = '/usr/local/apache/sites/kurt/htdocs/banner';
	$notes_uploadbaseurl  = '/uploads';
	$suppress_all_email   = '';
        $email_allemailto     = '';

	$logname2siteid{ 'Kurt'                         }  = 'kg000en';
	$sitesconfig{ 'kg000en' . 'sitename'            }  = 'kurtslap.andover.net';
	$sitesconfig{ 'kg000en' . 'logname'             }  = 'Kurt';
	$sitesconfig{ 'kg000en' . 'ad_stats_group'      }  = '';
	$sitesconfig{ 'kg000en' . 'ad_allocation_group' }  = '';
	$sitesconfig{ 'kg000en' . 'ad_positions'        }  = '1,2,5';
	$sitesconfig{ 'kg000en' . 'ad_layout'           }  = '0,60,*,375,125,60';
	$sitesconfig{ 'kg000en' . 'ad_log_download'     }  = 'RSYNC:localhost:5966:adlogs';
	$sitesconfig{ 'kg000en' . 'ad_info_upload'      }  = 'RSYNC:localhost:5966:addat';
	$sitesconfig{ 'kg000en' . 'ad_banner_upload'    }  = 'RSYNC:localhost:5966:adbanner';
	$sitesconfig{ 'kg000en' . 'ad_htmlad_upload'    }  = 'RSYNC:localhost:5966:htmlad';
	$sitesconfig{ 'kg000en' . 'ad_htmlad_set'       }  = '';
	$sitesconfig{ 'kg000en' . 'ad_restrictions'     }  = 'MEGABANNERS=0 ReservedPages=0 SmallAdsHeightRestricted=1';
	$sitesconfig{ 'kg000en' . 'ad_status'           }  = 'TESTDUMMY';

    }


# Global settings for all ad system scripts (things I wouldn't put in CVS)

    $backcolor            ||= '#DDFFFF';
    $mod_date             ||= 'May.03.2001';
    $can_run_megabanners  ||= 1;
    $verify_gifs_exists   ||= 1;			# Spit out errors if ad in ad_info.dat does not have a local GIF file
    $force_login          ||= 1;			# Force a username and password to access this script
    $reserved_pages_limit ||= 100;			# Performance limit on how many pages can be reserved to ads

    $system_baseurl       ||= 'http://adsystem.yoursitename.com';
    $email_admin          ||= 'adsystem@yoursitename.com';
    $email_subject_prefix ||= '[Network Ad System]';
    # $email_allemailto     ||= 'adtest@yoursitename.com';

    $mainmenu             ||= '/cgi-bin/ad_mainmenu.pl';
    $ad_mainmenu_url      ||= '/cgi-bin/ad_mainmenu.pl';
    $ad_report_url        ||= '/cgi-bin/ad_report.pl';
    $traffic_report_url   ||= '/cgi-bin/web_traffic_report.pl';
    $ad_allocedit_url     ||= '/cgi-bin/ad_allocations.pl';
    $ad_infoedit_url      ||= '/cgi-bin/ad_banners.pl';
    $ad_compedit_url      ||= '/cgi-bin/ad_campaigns.pl';
    $ad_mailedit_url      ||= '/cgi-bin/ad_mail_allocedit.pl';
    $ad_reservations_url  ||= '/cgi-bin/ad_reserved_pages.pl';
    $ad_reserved_domains_url ||= '/cgi-bin/ad_reserved_domains.pl';
    $ad_notes_url         ||= '/cgi-bin/ad_notes.pl';
    $ad_users_url         ||= '/cgi-bin/ad_users.pl';
    $ad_invoices_url      ||= '/cgi-bin/ad_invoices.pl';
    $ad_contactlists_url  ||= '/cgi-bin/ad_contactlists.pl';
    $ad_logs_url          ||= '/cgi-bin/ad_system_logs.pl';

    $graph_basepath       ||= '/usr/local/adsystem/htdocs/graphs';
    $graph_baseref        ||= '/graphs';

    $weblogpath           ||= '/usr/local/adsystem/logs';
    $ad_htmlad_path       ||= '/usr/local/adsystem/htdocs/htmlad';
    $ad_banner_path       ||= '/usr/local/adsystem/htdocs/banner';
    $gif_filepath         ||= $ad_banner_path;	# Path to verify local GIFs for each ad in adInfo.dat
    $adlogpath            ||= '/usr/local/adsystem/logs';
    $datfilepath          ||= '/usr/local/adsystem/dat';
    $adlocalpath          ||= '/usr/local/adsystem/local';

    $backupfilepath       ||= "$weblogpath/ad_info_backups";
    $adcompfile           ||= "$adlocalpath/ad_campaign_info.dat";
    $adrunsfile           ||= "$adlocalpath/ad_campaign_runs.dat";
    $adusersfile          ||= "$adlocalpath/ad_system_users.dat";
    $adinfofile           ||= "$datfilepath/ad_info.dat";
    $system_logfile       ||= "$adlocalpath/logs/system_log";
    $users_logfile        ||= "$adlocalpath/logs/users_log";
    $email_logfile        ||= "$adlocalpath/logs/email_log";

    $notes_uploadpath     ||= '/usr/local/adsystem/htdocs/uploads';
    $notes_uploadbaseurl  ||= '/uploads';
    $notes_messagepath    ||= "$adlocalpath/notes";
    $notes_idxfile        ||= "$notes_messagepath/ad_notes_idx.dat";

    $contactlists_uploadpath  ||= "$adlocalpath/contacts";
    $contactlists_idxfile     ||= "$adlocalpath/ad_contactlists_idx.dat";

    %adtypes = ( 1, 'Premium Large',
		 2, 'Display',
		 3, 'Upper Small',
		 4, 'Bottom Small',
		 5, 'Bottom Large');

    @trafficlogs_remote_logdirs = ( 'supersiteyeah.com',
				    someothersite,
				    thatsiteoverthere );

    $trafficlogs_host   = 'trafficlogs.yournetwork.com';
    $trafficlogs_module = 'trafficlogs';


# Adjust for any per-site or per-server funkiness in the siteconfig array
# I was going to put this all in a database table but just as well do it all 
# right here and not pollute these scripts with lots of DBI calls and database stuff.

# Ad system inteface options for web sites which serve ads:

    $logname2siteid{ 'YourWebSite.com'              }  = 'yw000en';
    $sitesconfig{ 'yw000en' . 'sitename'            }  = 'YourWebSite.com';
    $sitesconfig{ 'yw000en' . 'logname'             }  = 'YourWebSite.com';
    $sitesconfig{ 'yw000en' . 'ad_stats_group'      }  = '';
    $sitesconfig{ 'yw000en' . 'traffic_stats_group' }  = '';
    $sitesconfig{ 'yw000en' . 'site_content_group'  }  = 'GroupA';
    $sitesconfig{ 'yw000en' . 'ad_allocation_group' }  = '';
    $sitesconfig{ 'yw000en' . 'ad_positions'        }  = '1,2,3,5';
    $sitesconfig{ 'yw000en' . 'ad_layout'           }  = '0,60,*,125,125,60';
    $sitesconfig{ 'yw000en' . 'ad_log_download'     }  = 'RSYNC:ads.yourwebsite.com::adlogs';
    $sitesconfig{ 'yw000en' . 'ad_info_upload'      }  = 'RSYNC:ads.yourwebsite.com::addat';
    $sitesconfig{ 'yw000en' . 'ad_banner_upload'    }  = 'RSYNC:ads.yourwebsite.com::adbanner';
    $sitesconfig{ 'yw000en' . 'ad_htmlad_upload'    }  = 'RSYNC:ads.yourwebsite.com::htmlad';
    $sitesconfig{ 'yw000en' . 'ad_htmlad_set'       }  = '';
    $sitesconfig{ 'yw000en' . 'ad_restrictions'     }  = 'MEGABANNERS=0 SmallAdsHeightRestricted=1';
    $sitesconfig{ 'yw000en' . 'ad_status'           }  = 'ACTIVE';
    

    $logname2siteid{ 'Whackdot'                     }  = 'wd000en';
    $sitesconfig{ 'wd000en' . 'sitename'            }  = 'Whackdot.org';
    $sitesconfig{ 'wd000en' . 'logname'             }  = 'Whackdot';
    $sitesconfig{ 'wd000en' . 'ad_stats_group'      }  = '';
    $sitesconfig{ 'wd000en' . 'traffic_stats_group' }  = '';
    $sitesconfig{ 'wd000en' . 'site_content_group'  }  = 'GroupB';
    $sitesconfig{ 'wd000en' . 'ad_allocation_group' }  = '';
    $sitesconfig{ 'wd000en' . 'ad_positions'        }  = '1';
    $sitesconfig{ 'wd000en' . 'ad_layout'           }  = '0,60,*,125,125,60';
    $sitesconfig{ 'wd000en' . 'ad_log_download'     }  = 'RSYNC:localhost:5960:adlogs';
    $sitesconfig{ 'wd000en' . 'ad_info_upload'      }  = 'RSYNC:localhost:5962:addat';
    $sitesconfig{ 'wd000en' . 'ad_banner_upload'    }  = 'RSYNC:localhost:5962:adbanner';
    $sitesconfig{ 'wd000en' . 'ad_htmlad_upload'    }  = 'RSYNC:localhost:5962:htmlad';
    $sitesconfig{ 'wd000en' . 'ad_htmlad_set'       }  = 'htmlad_whackdot';
    $sitesconfig{ 'wd000en' . 'ad_image_server'     }  = 'images.whackdot.org';
    $sitesconfig{ 'wd000en' . 'ad_restrictions'     }  = 'MEGABANNERS=0';
    $sitesconfig{ 'wd000en' . 'ad_status'           }  = 'ACTIVE';

    $logname2siteid{ 'OpenMagazine'                 }  = 'om000en';
    $sitesconfig{ 'om000en' . 'sitename'            }  = 'OpenMagazine.net';
    $sitesconfig{ 'om000en' . 'logname'             }  = 'OpenMagazine';
    $sitesconfig{ 'om000en' . 'ad_stats_group'      }  = '';
    $sitesconfig{ 'om000en' . 'traffic_stats_group' }  = '';
    $sitesconfig{ 'om000en' . 'site_content_group'  }  = 'Open';
    $sitesconfig{ 'om000en' . 'ad_allocation_group' }  = '';
    $sitesconfig{ 'om000en' . 'ad_positions'        }  = '1,3,5';
    $sitesconfig{ 'om000en' . 'ad_layout'           }  = '0,60,*,125,125,60';
    $sitesconfig{ 'om000en' . 'ad_log_download'     }  = 'RSYNC:localhost:5968:adlogs';
    $sitesconfig{ 'om000en' . 'ad_info_upload'      }  = 'RSYNC:localhost:5968:addat';
    $sitesconfig{ 'om000en' . 'ad_banner_upload'    }  = 'RSYNC:localhost:5968:adbanner';
    $sitesconfig{ 'om000en' . 'ad_htmlad_upload'    }  = 'RSYNC:localhost:5968:htmlad';
    $sitesconfig{ 'om000en' . 'ad_htmlad_set'       }  = '';
    $sitesconfig{ 'om000en' . 'ad_restrictions'     }  = 'MEGABANNERS=?? ReservedDomains=0';
    $sitesconfig{ 'om000en' . 'ad_status'           }  = 'ACTIVE';


##END of lib

1;

